/*
 * File   : cdrom.h
 * Purpose: This file contains all global definations of cdrom.c.
 * Autor  : Andreas Theofilu
 *
 * Copyright (C) 1999 by Theos Soft.
 */

/* 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __CDROM_H
#define __CDROM_H

#define CD_NOAUDIO	1	/* No audio CD in drive */
#define CD_INVALID	2	/* No CD in drive */
#define CD_UNKNOWN	3	/* Unknown error occured */
#define CD_LIBVERS	4	/* wrong libcdaudio version */
#define CD_EDISCID	5	/* DiscID of CD does not match */
#define CD_EDEVICE	6	/* Invalid CD-ROM drive */
#define CD_ESTATUS	7	/* No status info available */
#define CD_ECDDBEN	8	/* No or invalid CDDB-Entry */

typedef struct CDDB_ENTRY
{
	char song[81];		/* Field: TTITLE# */
	char singer[81];	/* Field: EXTT# */
	char zeit[6];		/* Get time to play directly from disc */
	int  frame;		/* Frame offset */
} cddb_entry_t;

typedef struct CDDB_TITLE
{
	unsigned long discid;	/* Computed disc-ID */
	int tracks;		/* total number of tracks */
	char title[81];		/* Field: DTITLE */
        cddb_entry_t entry[30];
} cddb_title_t;

int cddbGetDiscInfo (cddb_title_t *cddb, unsigned long discid, char *device, char *path, char *category);
int cddb_sum (int n);

#endif	/* __CDROM_H */
