#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <cdaudio.h>

int cddb_sum (int n);

main ()
{
int fd;
char cdversion[20];
struct disc_info disc;
int i, a, t, n;
unsigned long discid;

	t = n = 0;
	cd_version (&cdversion[0], sizeof (cdversion));
	printf ("\nBibliotheksversion: %s\n", cdversion);

	if ((fd = cd_init_device ("/dev/cdrom")) == -1)
	{
	   fprintf (stderr, "Fehler! Konnte CDROM nicht oeffnen!\n");
	   exit (1);
	}

	if (cd_stat (fd, &disc) == -1)
	{
	   fprintf (stderr, "Fehler! Konnte die CD-Daten nicht lesen!\n");
	   cd_finish (fd);
	   exit (1);
	}

	cd_finish (fd);

	if (!disc.disc_present)
	{
	   printf ("Es befindet sich keine CD im Laufwerk!\n");
	   exit (0);
	}

	switch (disc.disc_mode)
	{
	   case CDAUDIO_PLAYING:
	      printf ("Die eingelegte CD wird gerade gespielt.\n");
	   break;

	   case CDAUDIO_PAUSED:
	      printf ("Die eingelegte CD pausiert gerade.\n");
	   break;

	   case CDAUDIO_COMPLETED:
	      printf ("Die eingelegte CD wurde vollstaendig gespielt.\n");
	   break;

	   case CDAUDIO_NOSTATUS:
	      printf ("Die eingelegte CD ist ohne Befund :-).\n");
	   break;

	   default:
	      fprintf (stderr, "Unbehebbarer Fehler!\n");
	      exit (1);
	}

	a = disc.disc_total_tracks;

	for (i = 0; i < a; i++)
	   n += cddb_sum ((disc.disc_track[i].track_pos.minutes * 60) +
		disc.disc_track[i].track_pos.seconds);

	t = ((disc.disc_track[a].track_pos.minutes * 60) +
	     disc.disc_track[a].track_pos.seconds) -
	     ((disc.disc_track[0].track_pos.minutes * 60) +
	     disc.disc_track[0].track_pos.seconds);

	discid = ((n % 0xff) << 24 | t << 8 | disc.disc_total_tracks);
	printf ("DISCID: %08x\n", discid);
	exit (0);
}

int cddb_sum (int n)
{
int ret;

        for (ret = 0; n > 0; n /= 10)
                ret += n % 10;

        return (ret);
}
